
[![Build Status](https://cicd.apps.glenux.net/api/badges/glenux/fosdem-recorder.cr/status.svg)](https://cicd.apps.glenux.net/glenux/fosdem-recorder.cr)
[![License](https://img.shields.io/badge/License-BSD_3--Clause-blue.svg)](https://opensource.org/licenses/BSD-3-Clause)
[![Donate on patreon](https://img.shields.io/badge/patreon-donate-orange.svg)](https://patreon.com/glenux)

# FOSDEM Recorder

A tool to schedule FOSDEM recordings and help you record the 5+ talks you
wanted to attend at the same time.

Only for the impatient who can't wait for the official videos to be made
available (usually this happens a few days after the event).

## Installation

If you have Crystal 1.7+ installed on your system:

    shards install
    shards build
    sudo cp bin/fosdem-recorder /usr/local/bin/fosdem-recorder

If you don't have crystal, you can also build it with docker:

    docker run --name fosdem-recorder \
        -v $(pwd):/app crystallang/crystal:1.7.1 \
        sh -c "cd /app && shards install && shards build"
    docker cp fosdem-recorder:/app/bin/fosdem-recorder fosdem-recorder
    docker rm fosdem-recorder
    mv fosdem-recorder /usr/local/bin/fosdem-recorder

## Usage

### Get information about given URL

Syntax:

```shell-session
$ fosdem-recorder info EVENT_URL
```

Real example:

```shell-session
$ fosdem-recorder info https://fosdem.org/2023/schedule/event/nasa/
Loading data from https://fosdem.org/2023/schedule/event/nasa/
FOSDEM 2023 - Open Source Software at NASA
* event start  = 2023-02-05 17:00:00 +01:00
* event stop   = 2023-02-05 17:50:00 +01:00
* event length = 00:51:00 (from now: 01:20:00)
* stream url   = https://stream.fosdem.org/janson.m3u8
```

### Schedule video download for given URL

Syntax:

```shell-session
$ fosdem-recorder download EVENT_URL
```

Real example:

```shell-session
$ fosdem-recorder download https://fosdem.org/2023/schedule/event/nasa/
Loading data from https://fosdem.org/2023/schedule/event/nasa/
Command: echo ffmpeg -i https://stream.fosdem.org/janson.m3u8 -c copy -bsf:a aac_adtstoasc -movflags frag_keyframe+empty_moov+default_base_moof+faststart -t 01:19:00 "FOSDEM-2023-Open-Source-Software-at-NASA.mp4" | at 17:00 2023-02-05
warning: commands will be executed using /bin/sh
job 635 at Sun Feb  5 17:00:00 2023
```

## Contributing

Send bug reports and patches by email to <opensource@glenux.net>


